var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Actionsheet = (_temp = _class = function (_Component) {
  _inherits(Actionsheet, _Component);

  function Actionsheet(props) {
    _classCallCheck(this, Actionsheet);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {};

    _this.onClick = function (e) {
      var target = e.target;
      if (target.classList.contains('actionsheet-mask')) {
        if (_this.props.onClickMask) {
          _this.props.onClickMask(e);
          e.stopPropagation();
        }
      } else if (target.classList.contains('actionsheet-option')) {
        var index = target.getAttribute('data-index');
        if (_this.props.onClick) {
          _this.props.onClick(e, _this.props.list[index], Number(index));
          e.stopPropagation();
        }
      } else if (target.classList.contains('actionsheet-cancel')) {
        if (_this.props.onClickCancel) {
          _this.props.onClickCancel(e);
          e.stopPropagation();
        }
      }
    };

    return _this;
  }

  Actionsheet.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        duration = _props.duration,
        show = _props.show,
        maskClassName = _props.maskClassName,
        maskStyle = _props.maskStyle,
        className = _props.className,
        style = _props.style,
        list = _props.list,
        groupStyle = _props.groupStyle,
        groupClassName = _props.groupClassName,
        optionStyle = _props.optionStyle,
        optionClassName = _props.optionClassName,
        cancelCaption = _props.cancelCaption,
        cancelStyle = _props.cancelStyle,
        cancelClassName = _props.cancelClassName,
        onClickCancel = _props.onClickCancel;

    return createPortal(React.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'mask actionsheet-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle), onClick: this.onClick },
      React.createElement(
        'div',
        { className: 'actionsheet' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style), 'data-animation': 'slideUp' },
        React.createElement(
          'div',
          { className: 'actionsheet-group' + (groupClassName ? ' ' + groupClassName : ''), style: groupStyle },
          list && list.map(function (item, index) {
            return React.createElement(
              'a',
              { className: 'actionsheet-option' + (optionClassName ? ' ' + optionClassName : ''), style: optionStyle, key: index, 'data-index': index },
              item.caption
            );
          })
        ),
        onClickCancel && React.createElement(
          'a',
          { className: 'actionsheet-cancel' + (cancelClassName ? ' ' + cancelClassName : ''), style: cancelStyle },
          cancelCaption
        )
      )
    ), this.props.portal || document.getElementById('root'));
  };

  return Actionsheet;
}(Component), _class.defaultProps = {
  cancelCaption: window._seeds_lang['cancel'] || '取消',
  optionClassName: 'border-b'
}, _temp);
export { Actionsheet as default };
Actionsheet.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object,
  show: PropTypes.bool,

  duration: PropTypes.number,

  list: PropTypes.array, // [{caption: string, onClick: func}]

  maskStyle: PropTypes.object,
  maskClassName: PropTypes.string,
  onClickMask: PropTypes.func,

  style: PropTypes.object,
  className: PropTypes.string,

  groupStyle: PropTypes.object,
  groupClassName: PropTypes.string,

  optionStyle: PropTypes.object,
  optionClassName: PropTypes.string,

  cancelStyle: PropTypes.object,
  cancelClassName: PropTypes.string,
  cancelCaption: PropTypes.node,
  onClickCancel: PropTypes.func,

  onClick: PropTypes.func
} : {};