var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Alert = (_temp = _class = function (_Component) {
  _inherits(Alert, _Component);

  function Alert(props) {
    _classCallCheck(this, Alert);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {};

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(Object.getArgs(e, _this.props.args));
      e.stopPropagation();
    };

    _this.onClickCancel = function (e) {
      if (_this.props.onClickCancel) _this.props.onClickCancel(Object.getArgs(e, _this.props.args));
      e.stopPropagation();
    };

    _this.onClickSubmit = function (e) {
      if (_this.props.onClickSubmit) _this.props.onClickSubmit(Object.getArgs(e, _this.props.args));
      e.stopPropagation();
    };

    return _this;
  }

  Alert.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        duration = _props.duration,
        show = _props.show,
        maskClassName = _props.maskClassName,
        maskStyle = _props.maskStyle,
        className = _props.className,
        style = _props.style,
        caption = _props.caption,
        captionStyle = _props.captionStyle,
        captionClassName = _props.captionClassName,
        contentStyle = _props.contentStyle,
        contentClassName = _props.contentClassName,
        icon = _props.icon,
        children = _props.children,
        submitCaption = _props.submitCaption,
        submitStyle = _props.submitStyle,
        submitClassName = _props.submitClassName,
        onClickSubmit = _props.onClickSubmit,
        disabled = _props.disabled,
        cancelCaption = _props.cancelCaption,
        cancelStyle = _props.cancelStyle,
        cancelClassName = _props.cancelClassName,
        onClickCancel = _props.onClickCancel;

    return createPortal(React.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'mask alert-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle), onClick: this.onClickMask },
      React.createElement(
        'div',
        { className: 'alert' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style), 'data-animation': 'zoom' },
        caption && React.createElement(
          'h1',
          { className: captionClassName, style: captionStyle },
          caption
        ),
        React.createElement(
          'div',
          { className: 'alert-content' + (contentClassName ? ' ' + contentClassName : ''), style: contentStyle },
          icon,
          children
        ),
        React.createElement(
          'div',
          { className: 'alert-handler' },
          onClickCancel && React.createElement(
            'a',
            { className: 'alert-cancel button lg' + (cancelClassName ? ' ' + cancelClassName : ''), style: cancelStyle, onClick: this.onClickCancel },
            cancelCaption
          ),
          onClickSubmit && React.createElement(
            'a',
            { className: 'alert-submit button lg' + (submitClassName ? ' ' + submitClassName : ''), style: submitStyle, onClick: this.onClickSubmit, disabled: disabled },
            submitCaption
          )
        )
      )
    ), this.props.portal || document.getElementById('root'));
  };

  return Alert;
}(Component), _class.defaultProps = {
  submitCaption: window._seeds_lang['ok'] || '确定',
  cancelCaption: window._seeds_lang['cancel'] || '取消'
}, _temp);
export { Alert as default };
Alert.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object,
  args: PropTypes.any,
  show: PropTypes.bool,

  duration: PropTypes.number,

  maskStyle: PropTypes.object,
  maskClassName: PropTypes.string,
  onClickMask: PropTypes.func,

  style: PropTypes.object,
  className: PropTypes.string,

  caption: PropTypes.node,
  captionStyle: PropTypes.object,
  captionClassName: PropTypes.string,

  icon: PropTypes.node,

  contentStyle: PropTypes.object,
  contentClassName: PropTypes.string,
  children: PropTypes.node,

  submitStyle: PropTypes.object,
  submitClassName: PropTypes.string,
  submitCaption: PropTypes.node,
  disabled: PropTypes.bool,
  onClickSubmit: PropTypes.func,

  cancelStyle: PropTypes.object,
  cancelClassName: PropTypes.string,
  cancelCaption: PropTypes.node,
  onClickCancel: PropTypes.func
} : {};