var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

var BiDoughnut = (_temp = _class = function (_Component) {
  _inherits(BiDoughnut, _Component);

  function BiDoughnut(props, context) {
    _classCallCheck(this, BiDoughnut);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.getDuration = function () {
      var _this$props = _this.props,
          duration = _this$props.duration,
          rotate = _this$props.rotate;

      var correctRotate = rotate > 360 ? 360 : rotate;
      var duration1 = duration / 360;
      var durationRotate = duration1 * correctRotate;
      var durationLeft = 0;
      var durationRight = durationRotate;
      if (correctRotate > 180) {
        durationRight = duration1 * 180;
        durationLeft = duration1 * (correctRotate - 180);
      }
      return {
        durationRotate: durationRotate,
        delayLeft: durationRight,
        durationLeft: durationLeft,
        durationRight: durationRight
      };
    };

    _this.getRotate = function () {
      var rotate = _this.props.rotate;

      var rotateLeft = -135; // 左circle旋转角度
      var rotateRight = -135 + rotate; // 右circle旋转角度
      if (rotate > 180) {
        rotateRight = 45;
        rotateLeft = -135 + (rotate - 180);
      }
      return {
        rotateLeft: rotateLeft,
        rotateRight: rotateRight
      };
    };

    _this.aniRotate = function () {
      // 时长与延时
      var duration = _this.getDuration();
      var durationLeft = duration.durationLeft;
      var delayLeft = duration.delayLeft;
      var durationRight = duration.durationRight;
      // 旋转
      var rotate = _this.getRotate();
      var rotateLeft = rotate.rotateLeft;
      var rotateRight = rotate.rotateRight;
      setTimeout(function () {
        if (_this.$elLeftCircle) {
          _this.$elLeftCircle.style.WebkitTransitionDuration = durationLeft + 'ms';
          _this.$elLeftCircle.style.WebkitTransitionDelay = delayLeft + 'ms';
        }
        if (_this.$elRightCircle) {
          _this.$elRightCircle.style.WebkitTransitionDuration = durationRight + 'ms';
        }
        if (_this.$elLeftCircle) {
          _this.$elLeftCircle.style.WebkitTransform = 'rotate(' + rotateLeft + 'deg)';
        }
        if (_this.$elRightCircle) {
          _this.$elRightCircle.style.WebkitTransform = 'rotate(' + rotateRight + 'deg)';
        }
      }, _this.props.delay);
    };

    return _this;
  }
  // 只有延迟100毫秒动画才会生效


  BiDoughnut.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        lineWidth = _props.lineWidth,
        size = _props.size,
        className = _props.className,
        children = _props.children,
        captionClassName = _props.captionClassName,
        captionStyle = _props.captionStyle;
    // 动画旋转

    this.aniRotate();
    return React.createElement(
      'div',
      { className: 'bi-doughtut ' + className, style: { width: size + 'px', height: size + 'px' } },
      React.createElement(
        'div',
        { className: 'bi-doughtut-wrapper left' },
        React.createElement('div', { ref: function ref(el) {
            _this2.$elLeftCircle = el;
          }, className: 'bi-doughtut-circle left', style: { borderWidth: lineWidth + 'px', width: size - lineWidth * 2 + 'px', height: size - lineWidth * 2 + 'px' } })
      ),
      React.createElement(
        'div',
        { className: 'bi-doughtut-wrapper right' },
        React.createElement('div', { ref: function ref(el) {
            _this2.$elRightCircle = el;
          }, className: 'bi-doughtut-circle right', style: { borderWidth: lineWidth + 'px', width: size - lineWidth * 2 + 'px', height: size - lineWidth * 2 + 'px' } })
      ),
      React.createElement(
        'div',
        { className: 'bi-doughtut-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
        children
      )
    );
  };

  return BiDoughnut;
}(Component), _class.defaultProps = {
  lineWidth: 3,
  size: 50,
  duration: 1000,
  rotate: 0,
  delay: 100,
  className: 'disabled'
}, _temp);
export { BiDoughnut as default };
BiDoughnut.propTypes = process.env.NODE_ENV !== "production" ? {
  lineWidth: PropTypes.number, // 边框宽度
  size: PropTypes.number, // 大小,px
  duration: PropTypes.number, // 时长
  rotate: PropTypes.number, // 最大360
  delay: PropTypes.number, // 延时

  className: PropTypes.string,

  children: PropTypes.node,
  captionClassName: PropTypes.string,
  captionStyle: PropTypes.object
} : {};