var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// require PrototypeDate.js
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import InputText from './../InputText';
import PickerDate from './../PickerDate';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var InputDate = (_temp = _class = function (_Component) {
  _inherits(InputDate, _Component);

  function InputDate(props) {
    _classCallCheck(this, InputDate);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onClick = function (value, args) {
      if (_this.props.onClick) _this.props.onClick(value, args);
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickSubmit = function (e) {
      if (!_this.$input) _this.$input = _this.refs.$ComponentInputText.$input;
      if (_this.props.onClickSubmit) {
        _this.props.onClickSubmit(e);
        return;
      }
      var value = _this.correctDate(e.activeText);
      if (!value) return;
      var options = e.activeOptions;
      // 赋值
      if (!_this.props.valueBindProp) _this.$input.value = value;
      _this.setState({
        show: !_this.state.show
      });
      if (_this.props.onChange) {
        _this.props.onChange(value, options, _this.props.args);
      }
    };

    _this.onClickCancel = function (e) {
      if (_this.props.onClickCancel) {
        _this.props.onClickCancel(e);
        return;
      }
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) {
        _this.props.onClickMask(e);
        return;
      }
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.correctDate = function (value) {
      var text = value;
      var _this$props = _this.props,
          type = _this$props.type,
          min = _this$props.min,
          max = _this$props.max,
          onError = _this$props.onError;

      var selectDate = text.toDate();
      var current = _this.$input.value;
      var error = _this.props.error;
      if (min && (/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/.test(min) || /^[0-9]{2}:[0-9]{2}$/.test(min))) {
        if (type === 'date' && selectDate.compareDate(min.toDate()) === -1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_less_than'] || '不能小于') + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        } else if (type === 'month' && selectDate.compareMonth(min.toDate()) === -1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_less_than'] || '不能小于') + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        } else if (type === 'time' && selectDate.compareTime(min.toDate()) === -1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_less_than'] || '不能小于') + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        } else if (type === 'datetime' && selectDate.compareDateTime(min.toDate()) === -1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_less_than'] || '不能小于') + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        }
      }
      if (max && (/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/.test(max) || /^[0-9]{2}:[0-9]{2}$/.test(max))) {
        if (type === 'date' && selectDate.compareDate(max.toDate()) === 1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_greater_than'] || '不能大于') + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        } else if (type === 'month' && selectDate.compareMonth(max.toDate()) === 1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_greater_than'] || '不能大于') + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        } else if (type === 'time' && selectDate.compareTime(max.toDate()) === 1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_greater_than'] || '不能大于') + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        } else if (type === 'datetime' && selectDate.compareDateTime(max.toDate()) === 1) {
          if (onError) {
            onError(_extends({ msg: (window._seeds_lang['hint_cannot_be_greater_than'] || '不能大于') + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        }
      }
      return text;
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  InputDate.prototype.componentDidMount = function componentDidMount() {
    this.$input = this.refs.$ComponentInputText.$input;
  };
  // 日期纠正


  InputDate.prototype.render = function render() {
    var _props = this.props,
        valueForKey = _props.valueForKey,
        split = _props.split,
        min = _props.min,
        max = _props.max,
        type = _props.type,
        onClick = _props.onClick,
        onChange = _props.onChange,
        onError = _props.onError,
        pickerStyle = _props.pickerStyle,
        pickerClassName = _props.pickerClassName,
        pickerMaskStyle = _props.pickerMaskStyle,
        pickerMaskClassName = _props.pickerMaskClassName,
        pickerShow = _props.pickerShow,
        onClickSubmit = _props.onClickSubmit,
        onClickCancel = _props.onClickCancel,
        onClickMask = _props.onClickMask,
        others = _objectWithoutProperties(_props, ['valueForKey', 'split', 'min', 'max', 'type', 'onClick', 'onChange', 'onError', 'pickerStyle', 'pickerClassName', 'pickerMaskStyle', 'pickerMaskClassName', 'pickerShow', 'onClickSubmit', 'onClickCancel', 'onClickMask']);

    return [React.createElement(InputText, _extends({ key: 'input', ref: '$ComponentInputText' }, others, { type: 'text', readOnly: true, onClick: this.onClick })), React.createElement(PickerDate, {
      valueForKey: valueForKey,
      split: split,
      type: type,
      value: this.$input ? this.$input.value : this.props.value, key: 'pickerdate',
      show: pickerShow === undefined ? this.state.show : pickerShow,
      style: pickerStyle, className: pickerClassName,
      maskStyle: pickerMaskStyle, maskClassName: pickerMaskClassName,
      onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel, onClickMask: this.onClickMask
    })];
  };

  return InputDate;
}(Component), _class.defaultProps = {
  split: '-',
  type: 'date'
}, _temp);
export { InputDate as default };
InputDate.propTypes = process.env.NODE_ENV !== "production" ? {
  valueBindProp: PropTypes.bool,
  valueForKey: PropTypes.string,
  split: PropTypes.string,
  type: PropTypes.string, // 'date | month | time | datetime'
  min: PropTypes.string, // YYYY-MM-DD
  max: PropTypes.string, // YYYY-MM-DD

  onClick: PropTypes.func,
  onChange: PropTypes.func,
  onError: PropTypes.func,

  // Picker
  pickerStyle: PropTypes.object,
  pickerClassName: PropTypes.string,
  pickerMaskStyle: PropTypes.object,
  pickerMaskClassName: PropTypes.string,
  // 自定义Picker事件
  pickerShow: PropTypes.bool,
  onClickSubmit: PropTypes.func,
  onClickCancel: PropTypes.func,
  onClickMask: PropTypes.func
} : {};