var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import InputText from './../InputText';
import Picker from './../Picker';

var InputPicker = (_temp = _class = function (_Component) {
  _inherits(InputPicker, _Component);

  function InputPicker(props) {
    _classCallCheck(this, InputPicker);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onClick = function (value, args) {
      if (_this.props.onClick) _this.props.onClick(value, args);
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickSubmit = function (e) {
      if (!_this.$input) _this.$input = _this.refs.$ComponentInputText.$input;
      if (_this.props.onClickSubmit) {
        _this.props.onClickSubmit(e);
        return;
      }
      var value = e.activeOptions[0].value;
      // 赋值
      if (!_this.props.valueBindProp) _this.$input.value = value;
      _this.setState({
        show: !_this.state.show
      });
      if (_this.props.onChange) {
        _this.props.onChange(value, e.activeOptions[0], _this.props.args);
      }
    };

    _this.onClickCancel = function (e) {
      if (_this.props.onClickCancel) {
        _this.props.onClickCancel(e);
        return;
      }
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) {
        _this.props.onClickMask(e);
        return;
      }
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  InputPicker.prototype.componentDidMount = function componentDidMount() {
    this.$el = this.refs.$ComponentInputText.$el;
    this.$input = this.refs.$ComponentInputText.$input;
  };

  InputPicker.prototype.render = function render() {
    var _props = this.props,
        valueForKey = _props.valueForKey,
        list = _props.list,
        onClick = _props.onClick,
        onChange = _props.onChange,
        pickerStyle = _props.pickerStyle,
        pickerClassName = _props.pickerClassName,
        pickerMaskStyle = _props.pickerMaskStyle,
        pickerMaskClassName = _props.pickerMaskClassName,
        pickerShow = _props.pickerShow,
        onClickSubmit = _props.onClickSubmit,
        onClickCancel = _props.onClickCancel,
        onClickMask = _props.onClickMask,
        others = _objectWithoutProperties(_props, ['valueForKey', 'list', 'onClick', 'onChange', 'pickerStyle', 'pickerClassName', 'pickerMaskStyle', 'pickerMaskClassName', 'pickerShow', 'onClickSubmit', 'onClickCancel', 'onClickMask']);

    return [React.createElement(InputText, _extends({ key: 'input', ref: '$ComponentInputText' }, others, { readOnly: true, onClick: this.onClick })), React.createElement(Picker, {
      list: list, valueForKey: valueForKey, value: this.$input ? this.$input.value : this.props.value, key: 'picker',
      show: pickerShow === undefined ? this.state.show : pickerShow,
      style: pickerStyle, className: pickerClassName,
      maskStyle: pickerMaskStyle, maskClassName: pickerMaskClassName,
      onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel, onClickMask: this.onClickMask
    })];
  };

  return InputPicker;
}(Component), _class.defaultProps = {}, _temp);
export { InputPicker as default };
InputPicker.propTypes = process.env.NODE_ENV !== "production" ? {
  valueBindProp: PropTypes.bool,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  valueForKey: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  list: PropTypes.array, // [{key: '', value: ''}]
  onClick: PropTypes.func,
  onChange: PropTypes.func,

  // Picker
  pickerStyle: PropTypes.object,
  pickerClassName: PropTypes.string,
  pickerMaskStyle: PropTypes.object,
  pickerMaskClassName: PropTypes.string,
  // 自定义Picker事件
  pickerShow: PropTypes.bool,
  onClickSubmit: PropTypes.func,
  onClickCancel: PropTypes.func,
  onClickMask: PropTypes.func
} : {};