var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Instance from './instance';

var InputRange = (_temp = _class = function (_Component) {
  _inherits(InputRange, _Component);

  function InputRange(props) {
    _classCallCheck(this, InputRange);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onChange = function (e) {
      if (_this.props.onChange) {
        _this.props.onChange(_this.$input.value, Object.getArgs(e, _this.props.args));
      }
    };

    return _this;
  }

  InputRange.prototype.componentDidMount = function componentDidMount() {
    var instance = new Instance(this.$el);
    this.instance = instance;
  };

  InputRange.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        disabled = _props.disabled,
        style = _props.style,
        className = _props.className,
        value = _props.value,
        min = _props.min,
        max = _props.max,
        step = _props.step;

    return React.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'range' + (className ? ' ' + className : ''), style: style },
      React.createElement('input', { disabled: disabled, ref: function ref(el) {
          _this2.$input = el;
        }, type: 'range', className: 'range-input', min: min, max: max, step: step, defaultValue: value }),
      React.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$tooltip = el;
          }, className: 'range-tooltip' },
        value
      )
    );
  };

  return InputRange;
}(Component), _class.defaultProps = {
  value: '0',
  min: '0',
  max: '100',
  step: '1'
}, _temp);
export { InputRange as default };
InputRange.propTypes = process.env.NODE_ENV !== "production" ? {
  args: PropTypes.any,
  style: PropTypes.object,
  className: PropTypes.string,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  min: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  max: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  step: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  disabled: PropTypes.bool,
  onChange: PropTypes.func
} : {};