var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Star from './../Star';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var InputStar = (_temp = _class = function (_Component) {
  _inherits(InputStar, _Component);

  function InputStar(props) {
    _classCallCheck(this, InputStar);

    return _possibleConstructorReturn(this, _Component.call(this, props));
  }

  InputStar.prototype.onChange = function onChange(e, argNum) {
    var _props = this.props,
        min = _props.min,
        onChange = _props.onChange,
        onError = _props.onError;

    var num = argNum;
    if (num < min) {
      if (onError) {
        onError('' + (window._seeds_lang['hint_cannot_be_less_than'] || '不能小于') + min + (window._seeds_lang['star'] || '颗星'));
      } else {
        num = min;
      }
    }
    if (onChange) onChange(num, Object.getArgs(e, this.props.args));
  };

  InputStar.prototype.render = function render() {
    var _this2 = this;

    var _props2 = this.props,
        max = _props2.max,
        min = _props2.min,
        value = _props2.value,
        className = _props2.className,
        style = _props2.style;

    var stars = [];
    for (var i = 1; i <= max; i++) {
      stars.push(i);
    }
    var current = value;
    if (current < min) current = min;
    return React.createElement(
      'div',
      { className: 'input-star' + (className ? ' ' + className : ''), style: style },
      stars.map(function (index) {
        return React.createElement(Star, { onClick: function onClick(e) {
            _this2.onChange(e, index);
          }, key: index, className: index <= current ? 'active' : '' });
      })
    );
  };

  return InputStar;
}(Component), _class.defaultProps = {
  args: null,
  value: 0,
  min: 0,
  max: 5
}, _temp);
export { InputStar as default };
InputStar.propTypes = process.env.NODE_ENV !== "production" ? {
  args: PropTypes.any,
  min: PropTypes.number,
  max: PropTypes.number,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  onChange: PropTypes.func,
  className: PropTypes.string,
  style: PropTypes.object
} : {};