var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Loading = (_temp = _class = function (_Component) {
  _inherits(Loading, _Component);

  function Loading(props) {
    _classCallCheck(this, Loading);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {};
    return _this;
  }

  Loading.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        type = _props.type,
        maskStyle = _props.maskStyle,
        maskClassName = _props.maskClassName,
        maskBefore = _props.maskBefore,
        style = _props.style,
        iconClassName = _props.iconClassName,
        iconSrc = _props.iconSrc,
        caption = _props.caption;

    var content = React.createElement(
      'div',
      null,
      '\u52A0\u8F7D\u4E2D...'
    );
    if (type === 'custom') {
      // 自定义样式
      content = React.createElement(
        'div',
        { className: 'loading-custom', style: style },
        (iconClassName || iconSrc) && React.createElement('span', { style: iconSrc ? { backgroundImage: 'url(' + iconSrc + ')' } : {}, className: 'loading-custom-icon' + (iconClassName ? ' ' + iconClassName : '') }),
        caption && React.createElement(
          'p',
          { className: 'loading-custom-caption' },
          caption
        )
      );
    } else if (type === 'filling') {
      // 填料环
      content = React.createElement(
        'div',
        { className: 'loading-filling active', style: style },
        React.createElement('div', { className: 'loading-filling-icon' })
      );
    } else if (type === 'floating') {
      // 流光
      content = React.createElement(
        'div',
        { className: 'loading-floating animated', style: style },
        React.createElement(
          'div',
          { className: 'loading-floating-icon' },
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' })
        ),
        React.createElement(
          'div',
          { className: 'loading-floating-caption' },
          caption
        )
      );
    }
    if (this.props.portal) {
      return createPortal(React.createElement(
        'div',
        { className: 'loading-mask mask active' + (maskClassName ? ' ' + maskClassName : ''), style: maskStyle },
        maskBefore,
        content
      ), this.props.portal);
    }
    return React.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'loading-mask mask active' + (maskClassName ? ' ' + maskClassName : ''), style: maskStyle },
      maskBefore,
      content
    );
  };

  return Loading;
}(Component), _class.defaultProps = {
  caption: window._seeds_lang['loading'] || '正在加载...',
  type: 'floating'
}, _temp);
export { Loading as default };
Loading.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object, // 传送至DOM
  type: PropTypes.string, // floating | filling | custom

  maskStyle: PropTypes.object,
  maskClassName: PropTypes.string,
  maskBefore: PropTypes.node,

  style: PropTypes.object,

  iconClassName: PropTypes.string,
  iconSrc: PropTypes.string,
  caption: PropTypes.string
} : {};