var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Alert from './../Alert';
import NumBox from './../NumBox';

var NumBoxPop = (_temp = _class = function (_Component) {
  _inherits(NumBoxPop, _Component);

  function NumBoxPop(props) {
    _classCallCheck(this, NumBoxPop);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onChange = function (value) {
      _this.setState({
        value: value
      });
    };

    _this.onClickSubmit = function (args) {
      if (_this.props.onClickSubmit) _this.props.onClickSubmit(_this.state.value, args);
    };

    _this.onClickCancel = function (args) {
      var value = _this.props.value;

      _this.setState({
        value: value
      });
      if (_this.props.onClickCancel) _this.props.onClickCancel(value, args);
    };

    _this.state = {
      value: props.value || '1'
    };
    return _this;
  }

  NumBoxPop.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        args = _props.args,
        caption = _props.caption,
        value = _props.value,
        onClickCancel = _props.onClickCancel,
        onClickSubmit = _props.onClickSubmit,
        others = _objectWithoutProperties(_props, ['args', 'caption', 'value', 'onClickCancel', 'onClickSubmit']);

    return React.createElement(
      Alert,
      { args: args, ref: function ref(el) {
          _this2.$el = el;
        }, duration: 0, caption: caption, show: true, onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel },
      React.createElement(NumBox, _extends({
        ref: function ref(el) {
          _this2.$numbox = el;
        },
        value: this.state.value,
        style: { margin: '0 auto' },
        className: 'flex xl',
        onChange: this.onChange,
        autoFocus: true,
        autoSelect: true
      }, others))
    );
  };

  return NumBoxPop;
}(Component), _class.defaultProps = {
  caption: '修改购买数量'
}, _temp);
export { NumBoxPop as default };
NumBoxPop.propTypes = process.env.NODE_ENV !== "production" ? {
  args: PropTypes.any,
  // 容器
  caption: PropTypes.string,
  // 文本框
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  // events
  onClickCancel: PropTypes.func,
  onClickSubmit: PropTypes.func
} : {};