var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import NumBox from './../NumBox';
import NumBoxPop from './../NumBoxPop';

var NumBoxPopPointer = (_temp = _class = function (_Component) {
  _inherits(NumBoxPopPointer, _Component);

  function NumBoxPopPointer(props) {
    _classCallCheck(this, NumBoxPopPointer);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onClickCancel = function () {
      _this.setState({ show: false });
    };

    _this.onClickPlus = function (value, args) {
      if (_this.props.onChange) _this.props.onChange(value, args);
    };

    _this.onClickMinus = function (value, args) {
      if (_this.props.onChange) _this.props.onChange(value, args);
    };

    _this.onClickSubmit = function (value, args) {
      // Callback
      if (_this.props.onChange) _this.props.onChange(value, args);
      // 隐藏
      _this.setState({
        show: false
      });
    };

    _this.onClickNumBox = function () {
      _this.setState({
        show: true
      });
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  NumBoxPopPointer.prototype.render = function render() {
    var _props = this.props,
        args = _props.args,
        containerClassName = _props.containerClassName,
        containerStyle = _props.containerStyle,
        className = _props.className,
        style = _props.style,
        value = _props.value,
        disabled = _props.disabled,
        min = _props.min,
        max = _props.max,
        digits = _props.digits,
        unitClassName = _props.unitClassName,
        unitStyle = _props.unitStyle,
        unit = _props.unit,
        onChange = _props.onChange,
        others = _objectWithoutProperties(_props, ['args', 'containerClassName', 'containerStyle', 'className', 'style', 'value', 'disabled', 'min', 'max', 'digits', 'unitClassName', 'unitStyle', 'unit', 'onChange']);

    var show = this.state.show;

    return React.createElement(
      'div',
      { style: Object.assign({ position: 'relative' }, containerStyle), className: containerClassName },
      React.createElement(NumBox, {
        args: args,
        className: className,
        style: style,
        value: value,
        disabled: disabled,
        readOnly: true,
        min: min,
        max: max,
        digits: digits,
        onClickInput: this.onClickNumBox,
        onClickPlus: this.onClickPlus,
        onClickMinus: this.onClickMinus
      }),
      React.createElement(
        'span',
        { style: unitStyle, className: unitClassName },
        unit || ''
      ),
      show && React.createElement(NumBoxPop, _extends({
        args: args,
        value: value,
        min: min,
        max: max,
        digits: digits,
        onClickCancel: this.onClickCancel,
        onClickSubmit: this.onClickSubmit
      }, others))
    );
  };

  return NumBoxPopPointer;
}(Component), _class.defaultProps = {
  className: 'sm',
  unitStyle: {
    fontSize: '13px',
    marginLeft: '8px'
  }
}, _temp);
export { NumBoxPopPointer as default };
NumBoxPopPointer.propTypes = process.env.NODE_ENV !== "production" ? {
  args: PropTypes.any,
  containerClassName: PropTypes.string,
  containerStyle: PropTypes.object,
  // numbox
  className: PropTypes.string,
  style: PropTypes.object,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  digits: PropTypes.oneOfType([PropTypes.bool, PropTypes.number]),
  min: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  max: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  disabled: PropTypes.bool,
  // unit
  unitClassName: PropTypes.string,
  unitStyle: PropTypes.object,
  unit: PropTypes.string,
  // events
  onChange: PropTypes.func
} : {};