var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Instance from './instance.js';
import BScroll from 'better-scroll';

var PDFView = (_temp = _class = function (_Component) {
  _inherits(PDFView, _Component);

  function PDFView(props) {
    _classCallCheck(this, PDFView);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.instance = function () {
      var _this$props = _this.props,
          src = _this$props.src,
          pictures = _this$props.pictures,
          errorHTML = _this$props.errorHTML,
          loadHTML = _this$props.loadHTML,
          cMapUrl = _this$props.cMapUrl;

      if (!src && !pictures) return;
      var bscroll = null;
      var instance = new Instance(_this.$el, {
        src: src,
        pictures: pictures,
        errorHTML: errorHTML,
        loadHTML: loadHTML,
        // options, // (废弃)
        cMapUrl: cMapUrl,
        onLoad: function onLoad() {
          bscroll = new BScroll('.pdf-container', {
            scrollX: true,
            zoom: {
              start: 1,
              min: 1,
              max: 4
            }
          });
        }
      });
      _this.bscroll = bscroll;
      _this.instance = instance;
    };

    return _this;
  }

  PDFView.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _props = this.props,
        src = _props.src,
        pictures = _props.pictures,
        errorHTML = _props.errorHTML,
        loadHTML = _props.loadHTML,
        cMapUrl = _props.cMapUrl;

    if (src && src !== prevProps.src || pictures && pictures !== prevProps.pictures) {
      if (!this.instance) {
        this.instance();
      } else {
        this.instance.update({
          src: src,
          pictures: pictures,
          errorHTML: errorHTML,
          loadHTML: loadHTML,
          // options // (废弃)
          cMapUrl: cMapUrl
        });
      }
    }
  };

  PDFView.prototype.componentDidMount = function componentDidMount() {
    this.instance();
  };

  PDFView.prototype.render = function render() {
    var _this2 = this;

    var _props2 = this.props,
        src = _props2.src,
        pictures = _props2.pictures,
        errorHTML = _props2.errorHTML,
        loadHTML = _props2.loadHTML,
        cMapUrl = _props2.cMapUrl,
        others = _objectWithoutProperties(_props2, ['src', 'pictures', 'errorHTML', 'loadHTML', 'cMapUrl']);

    if (!src && !pictures) {
      return null;
    }
    return React.createElement(
      'div',
      _extends({ className: 'pdf-container' }, others, { ref: function ref(el) {
          _this2.$el = el;
        } }),
      React.createElement('div', { className: 'pdf-wrapper' })
    );
  };

  return PDFView;
}(Component), _class.defaultProps = {
  loadHTML: '加载中',
  errorHTML: '文件加载失败'
}, _temp);
export { PDFView as default };
PDFView.propTypes = process.env.NODE_ENV !== "production" ? {
  pictures: PropTypes.array, // 图片地址
  src: PropTypes.string, // pdf地址或data:application/pdf;base64,开头的base64pdf流文件
  errorHTML: PropTypes.string, // 加载错误时显示的信息
  loadHTML: PropTypes.string, // 加载时显示的信息
  // options: PropTypes.object // getDocument选项: cMapUrl: '/demo/cmaps/', cMapPacked: true(废弃)
  cMapUrl: PropTypes.string
} : {};