var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Page from './../Page';
import Instance from './instance.js';

var PagePull = (_temp = _class = function (_Component) {
  _inherits(PagePull, _Component);

  function PagePull(props, context) {
    _classCallCheck(this, PagePull);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.componentDidMount = function () {
      var instance = new Instance(_this.$el, {
        drag: true,
        transition: _this.props.transition || 'push',
        onShowedLeft: _this.props.onShowedLeft,
        onShowedRight: _this.props.onShowedRight
      });
      _this.instance = instance;
    };

    return _this;
  }

  PagePull.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        lSide = _props.lSide,
        lSideStyle = _props.lSideStyle,
        lSideClassName = _props.lSideClassName,
        rSide = _props.rSide,
        rSideStyle = _props.rSideStyle,
        rSideClassName = _props.rSideClassName,
        drag = _props.drag,
        children = _props.children,
        transition = _props.transition,
        others = _objectWithoutProperties(_props, ['lSide', 'lSideStyle', 'lSideClassName', 'rSide', 'rSideStyle', 'rSideClassName', 'drag', 'children', 'transition']);

    return React.createElement(
      'div',
      { className: 'page-pull', ref: function ref(el) {
          _this2.$el = el;
        } },
      React.createElement(
        Page,
        others,
        children,
        React.createElement('div', { className: 'mask' })
      ),
      lSide && React.createElement(
        'aside',
        { className: 'page-side-left' + (lSideClassName ? ' ' + lSideClassName : ''), style: lSideStyle, 'data-transition': transition, ref: function ref(el) {
            _this2.$lSide = el;
          } },
        lSide
      ),
      rSide && React.createElement(
        'aside',
        { className: 'page-side-right' + (rSideClassName ? ' ' + rSideClassName : ''), style: rSideStyle, 'data-transition': transition, ref: function ref(el) {
            _this2.$rSide = el;
          } },
        rSide
      )
    );
  };

  return PagePull;
}(Component), _class.defaultProps = {
  drag: true,
  transition: 'push'
}, _temp);
export { PagePull as default };
PagePull.propTypes = process.env.NODE_ENV !== "production" ? {
  // Page
  children: PropTypes.node,
  // Side 侧边栏
  drag: PropTypes.bool,
  lSide: PropTypes.node, // 左侧边栏
  lSideStyle: PropTypes.object,
  lSideClassName: PropTypes.string,
  rSide: PropTypes.node, // 右侧边栏
  rSideStyle: PropTypes.object,
  rSideClassName: PropTypes.string,
  transition: PropTypes.string, // 过渡动画, push | reveal
  onShowedLeft: PropTypes.func,
  onShowedRight: PropTypes.func
} : {};