var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import DB from './../DB';

var SearchBoard = (_temp = _class = function (_Component) {
  _inherits(SearchBoard, _Component);

  function SearchBoard(props, context) {
    _classCallCheck(this, SearchBoard);

    // 初始化标签
    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.onClear = function () {
      DB.removeStore(_this.props.dbKey);
      _this.setState({
        tags: []
      });
      if (_this.props.onClear) _this.props.onClear();
    };

    _this.add = function (item) {
      if (!item.value) return;
      var tags = DB.getStore(_this.props.dbKey) || [];
      // 删除重复项
      for (var i in tags) {
        if (tags[i].value === item.value) {
          tags.splice(i, 1);
          break;
        }
      }
      // 添加到第一项
      tags.unshift(item);
      DB.setStore(_this.props.dbKey, tags);
      _this.setState({
        tags: tags
      });
    };

    _this.state = {
      tags: DB.getStore(_this.props.dbKey) || []
    };
    return _this;
  }
  // 清空历史记录

  // 新增历史记录


  SearchBoard.prototype.render = function render() {
    var tags = this.state.tags;
    var _props = this.props,
        style = _props.style,
        className = _props.className,
        show = _props.show,
        expandCaption = _props.expandCaption,
        expandTags = _props.expandTags,
        _onClick = _props.onClick,
        onClickExpand = _props.onClickExpand,
        children = _props.children;

    var isHide = false;
    if (this.props.showValidTags && tags.length === 0) {
      isHide = true;
    }
    var DOM = null;
    if (!isHide) {
      DOM = React.createElement(
        'div',
        { className: 'searchboard ' + (className ? ' ' + className : '') + (show ? '' : ' hide'), style: style },
        tags.length > 0 && React.createElement(
          'div',
          { className: 'searchboard-caption' },
          React.createElement(
            'div',
            { className: 'searchboard-caption-title' },
            '\u641C\u7D22\u5386\u53F2'
          ),
          React.createElement(
            'div',
            { className: 'searchboard-caption-ricon', onClick: this.onClear },
            React.createElement('i', { className: 'searchboard-icon-trash' }),
            React.createElement(
              'span',
              null,
              '\u6E05\u9664'
            )
          )
        ),
        tags.map(function (item, index) {
          return React.createElement(
            'div',
            { className: 'searchboard-tag', onClick: function onClick() {
                if (_onClick) _onClick(item, index);
              }, key: index },
            item.value
          );
        }),
        expandCaption && React.createElement(
          'div',
          { className: 'searchboard-caption' },
          React.createElement(
            'div',
            { className: 'searchboard-caption-title' },
            expandCaption
          )
        ),
        expandTags && expandTags.map(function (item, index) {
          return React.createElement(
            'div',
            { className: 'searchboard-tag', onClick: function onClick() {
                if (onClickExpand) onClickExpand(item, index);
              }, key: index },
            item.value
          );
        }),
        children
      );
    }
    return DOM;
  };

  return SearchBoard;
}(Component), _class.defaultProps = {
  show: true,
  showValidTags: true,
  className: 'border-b',
  dbKey: 'app_search_history'
}, _temp);
export { SearchBoard as default };
SearchBoard.propTypes = process.env.NODE_ENV !== "production" ? {
  style: PropTypes.object,
  className: PropTypes.string,
  dbKey: PropTypes.string, // 存储到db中的key
  show: PropTypes.bool,
  showValidTags: PropTypes.bool, // 如果没有历史记录是否隐藏面板
  onClick: PropTypes.func,
  onClear: PropTypes.func,
  expandCaption: PropTypes.string, // 扩展标题
  expandTags: PropTypes.array, // 扩展标签, 格式: {value: 'xx'}
  onClickExpand: PropTypes.func,
  children: PropTypes.node
} : {};