var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// require PrototypeArray.js
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Instance from './instance.js';

var Tree = (_temp = _class = function (_Component) {
  _inherits(Tree, _Component);

  function Tree(props) {
    _classCallCheck(this, Tree);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (JSON.stringify(prevProps.list) !== JSON.stringify(_this.props.list)) {
        if (_this.props.list && _this.props.list.length) {
          var selected = _this.props.selected;

          var list = Object.clone(_this.props.list);
          if (JSON.stringify(list).indexOf('"children"') !== -1) {
            list = list.flattenTree();
          }
          // 设置已选中
          if (Array.isArray(selected) && selected.length) {
            for (var _iterator = selected, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
              var _ref;

              if (_isArray) {
                if (_i >= _iterator.length) break;
                _ref = _iterator[_i++];
              } else {
                _i = _iterator.next();
                if (_i.done) break;
                _ref = _i.value;
              }

              var opt = _ref;

              _this.instance.addSelected(opt);
            }
          }
          // 开始渲染
          _this.instance.setData(list);
          _this.instance.update();
        } else {
          _this.instance.setData([]);
          _this.instance.update();
        }
      }
    };

    _this.componentDidMount = function () {
      if (_this.instance) return;
      var _this$props = _this.props,
          multiple = _this$props.multiple,
          checkbox = _this$props.checkbox,
          bar = _this$props.bar,
          buttonAddHTML = _this$props.buttonAddHTML,
          buttonAddClassName = _this$props.buttonAddClassName,
          buttonAddSrc = _this$props.buttonAddSrc,
          onClickAdd = _this$props.onClickAdd,
          buttonDelHTML = _this$props.buttonDelHTML,
          buttonDelClassName = _this$props.buttonDelClassName,
          buttonDelSrc = _this$props.buttonDelSrc,
          onClickDel = _this$props.onClickDel,
          onClickLastChild = _this$props.onClickLastChild,
          onData = _this$props.onData;
      // 更新数据

      var list = Object.clone(_this.props.list);
      if (JSON.stringify(list).indexOf('"children"') !== -1) {
        list = list.flattenTree();
      }
      var instance = new Instance(_this.$tree, {
        data: list,
        multiple: multiple,
        checkbox: checkbox,
        bar: bar,
        buttonAddHTML: buttonAddHTML,
        buttonAddClassName: buttonAddClassName,
        buttonAddSrc: buttonAddSrc,
        onClickAdd: onClickAdd,
        buttonDelHTML: buttonDelHTML,
        buttonDelClassName: buttonDelClassName,
        buttonDelSrc: buttonDelSrc,
        onClickDel: onClickDel,
        onClickLastChild: onClickLastChild, // 没有子节点
        onClick: _this.onClick,
        onData: onData
      });
      _this.instance = instance;
      // 设置已选中
      var selected = _this.props.selected;

      if (Array.isArray(selected) && selected.length) {
        for (var _iterator2 = selected, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
          var _ref2;

          if (_isArray2) {
            if (_i2 >= _iterator2.length) break;
            _ref2 = _iterator2[_i2++];
          } else {
            _i2 = _iterator2.next();
            if (_i2.done) break;
            _ref2 = _i2.value;
          }

          var opt = _ref2;

          _this.instance.addSelected(opt);
        }
      }
      _this.instance.update();
    };

    _this.onClick = function (s) {
      var selected = _this.props.selected;

      var list = Object.clone(_this.props.list);
      if (JSON.stringify(list).indexOf('"children"') !== -1) {
        list = list.flattenTree();
      }
      // item
      var id = s.targetLine.getAttribute('data-id');
      var item = list.getFlattenTreeNode(id);
      // isActived
      var isActived = selected ? selected.filter(function (option) {
        if (option.id === id) return true;
        return false;
      }) : null;
      if (isActived && isActived.length > 0) {
        isActived = true;
      } else {
        isActived = false;
      }
      // childrenCount
      var childrenCount = 0;
      var ul = s.targetLine.nextElementSibling;
      if (ul && ul.tagName === 'UL') {
        childrenCount = ul.children.length;
      }
      // isExtend
      var isExtend = s.targetLine.classList.contains('extend');

      if (_this.props.onClick) _this.props.onClick(s, item, isActived, isExtend, childrenCount);
    };

    return _this;
  }

  Tree.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        style = _props.style,
        className = _props.className,
        treeStyle = _props.treeStyle,
        treeClassName = _props.treeClassName;

    return React.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'tree-box' + (className ? ' ' + className : ''), style: style },
      React.createElement('ul', { ref: function ref(el) {
          _this2.$tree = el;
        }, className: 'tree' + (treeClassName ? ' ' + treeClassName : ''), style: treeStyle })
    );
  };

  return Tree;
}(Component), _class.defaultProps = {
  multiple: true,
  list: []
}, _temp);
export { Tree as default };
Tree.propTypes = process.env.NODE_ENV !== "production" ? {
  style: PropTypes.object,
  className: PropTypes.string,
  treeStyle: PropTypes.object,
  treeClassName: PropTypes.string,

  multiple: PropTypes.bool, // 是否需要多选
  checkbox: PropTypes.bool, // 是否可选
  bar: PropTypes.oneOfType([// 选中栏
  PropTypes.string, PropTypes.node]),
  selected: PropTypes.array, // [{id: '', name: '', parentid: ''}]
  list: PropTypes.array, // [{id: '', name: '', parentid: ''}]

  buttonAddHTML: PropTypes.string,
  buttonAddClassName: PropTypes.string,
  buttonAddSrc: PropTypes.string,
  onClickAdd: PropTypes.func,

  buttonDelHTML: PropTypes.string,
  buttonDelClassName: PropTypes.string,
  buttonDelSrc: PropTypes.string,
  onClickDel: PropTypes.func,

  onClickLastChild: PropTypes.func,

  onClick: PropTypes.func,
  onData: PropTypes.func
} : {};