'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Actionsheet = (_temp = _class = function (_Component) {
  _inherits(Actionsheet, _Component);

  function Actionsheet(props) {
    _classCallCheck(this, Actionsheet);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {};

    _this.onClick = function (e) {
      var target = e.target;
      if (target.classList.contains('actionsheet-mask')) {
        if (_this.props.onClickMask) {
          _this.props.onClickMask(e);
          e.stopPropagation();
        }
      } else if (target.classList.contains('actionsheet-option')) {
        var index = target.getAttribute('data-index');
        if (_this.props.onClick) {
          _this.props.onClick(e, _this.props.list[index], Number(index));
          e.stopPropagation();
        }
      } else if (target.classList.contains('actionsheet-cancel')) {
        if (_this.props.onClickCancel) {
          _this.props.onClickCancel(e);
          e.stopPropagation();
        }
      }
    };

    return _this;
  }

  Actionsheet.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        duration = _props.duration,
        show = _props.show,
        maskClassName = _props.maskClassName,
        maskStyle = _props.maskStyle,
        className = _props.className,
        style = _props.style,
        list = _props.list,
        groupStyle = _props.groupStyle,
        groupClassName = _props.groupClassName,
        optionStyle = _props.optionStyle,
        optionClassName = _props.optionClassName,
        cancelCaption = _props.cancelCaption,
        cancelStyle = _props.cancelStyle,
        cancelClassName = _props.cancelClassName,
        onClickCancel = _props.onClickCancel;

    return (0, _reactDom.createPortal)(_react2.default.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'mask actionsheet-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle), onClick: this.onClick },
      _react2.default.createElement(
        'div',
        { className: 'actionsheet' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style), 'data-animation': 'slideUp' },
        _react2.default.createElement(
          'div',
          { className: 'actionsheet-group' + (groupClassName ? ' ' + groupClassName : ''), style: groupStyle },
          list && list.map(function (item, index) {
            return _react2.default.createElement(
              'a',
              { className: 'actionsheet-option' + (optionClassName ? ' ' + optionClassName : ''), style: optionStyle, key: index, 'data-index': index },
              item.caption
            );
          })
        ),
        onClickCancel && _react2.default.createElement(
          'a',
          { className: 'actionsheet-cancel' + (cancelClassName ? ' ' + cancelClassName : ''), style: cancelStyle },
          cancelCaption
        )
      )
    ), this.props.portal || document.getElementById('root'));
  };

  return Actionsheet;
}(_react.Component), _class.defaultProps = {
  cancelCaption: window._seeds_lang['cancel'] || '取消',
  optionClassName: 'border-b'
}, _temp);
exports.default = Actionsheet;
Actionsheet.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: _propTypes2.default.object,
  show: _propTypes2.default.bool,

  duration: _propTypes2.default.number,

  list: _propTypes2.default.array, // [{caption: string, onClick: func}]

  maskStyle: _propTypes2.default.object,
  maskClassName: _propTypes2.default.string,
  onClickMask: _propTypes2.default.func,

  style: _propTypes2.default.object,
  className: _propTypes2.default.string,

  groupStyle: _propTypes2.default.object,
  groupClassName: _propTypes2.default.string,

  optionStyle: _propTypes2.default.object,
  optionClassName: _propTypes2.default.string,

  cancelStyle: _propTypes2.default.object,
  cancelClassName: _propTypes2.default.string,
  cancelCaption: _propTypes2.default.node,
  onClickCancel: _propTypes2.default.func,

  onClick: _propTypes2.default.func
} : {};
module.exports = exports['default'];