'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Alert = (_temp = _class = function (_Component) {
  _inherits(Alert, _Component);

  function Alert(props) {
    _classCallCheck(this, Alert);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {};

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(Object.getArgs(e, _this.props.args));
      e.stopPropagation();
    };

    _this.onClickCancel = function (e) {
      if (_this.props.onClickCancel) _this.props.onClickCancel(Object.getArgs(e, _this.props.args));
      e.stopPropagation();
    };

    _this.onClickSubmit = function (e) {
      if (_this.props.onClickSubmit) _this.props.onClickSubmit(Object.getArgs(e, _this.props.args));
      e.stopPropagation();
    };

    return _this;
  }

  Alert.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        duration = _props.duration,
        show = _props.show,
        maskClassName = _props.maskClassName,
        maskStyle = _props.maskStyle,
        className = _props.className,
        style = _props.style,
        caption = _props.caption,
        captionStyle = _props.captionStyle,
        captionClassName = _props.captionClassName,
        contentStyle = _props.contentStyle,
        contentClassName = _props.contentClassName,
        icon = _props.icon,
        children = _props.children,
        submitCaption = _props.submitCaption,
        submitStyle = _props.submitStyle,
        submitClassName = _props.submitClassName,
        onClickSubmit = _props.onClickSubmit,
        disabled = _props.disabled,
        cancelCaption = _props.cancelCaption,
        cancelStyle = _props.cancelStyle,
        cancelClassName = _props.cancelClassName,
        onClickCancel = _props.onClickCancel;

    return (0, _reactDom.createPortal)(_react2.default.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'mask alert-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle), onClick: this.onClickMask },
      _react2.default.createElement(
        'div',
        { className: 'alert' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style), 'data-animation': 'zoom' },
        caption && _react2.default.createElement(
          'h1',
          { className: captionClassName, style: captionStyle },
          caption
        ),
        _react2.default.createElement(
          'div',
          { className: 'alert-content' + (contentClassName ? ' ' + contentClassName : ''), style: contentStyle },
          icon,
          children
        ),
        _react2.default.createElement(
          'div',
          { className: 'alert-handler' },
          onClickCancel && _react2.default.createElement(
            'a',
            { className: 'alert-cancel button lg' + (cancelClassName ? ' ' + cancelClassName : ''), style: cancelStyle, onClick: this.onClickCancel },
            cancelCaption
          ),
          onClickSubmit && _react2.default.createElement(
            'a',
            { className: 'alert-submit button lg' + (submitClassName ? ' ' + submitClassName : ''), style: submitStyle, onClick: this.onClickSubmit, disabled: disabled },
            submitCaption
          )
        )
      )
    ), this.props.portal || document.getElementById('root'));
  };

  return Alert;
}(_react.Component), _class.defaultProps = {
  submitCaption: window._seeds_lang['ok'] || '确定',
  cancelCaption: window._seeds_lang['cancel'] || '取消'
}, _temp);
exports.default = Alert;
Alert.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: _propTypes2.default.object,
  args: _propTypes2.default.any,
  show: _propTypes2.default.bool,

  duration: _propTypes2.default.number,

  maskStyle: _propTypes2.default.object,
  maskClassName: _propTypes2.default.string,
  onClickMask: _propTypes2.default.func,

  style: _propTypes2.default.object,
  className: _propTypes2.default.string,

  caption: _propTypes2.default.node,
  captionStyle: _propTypes2.default.object,
  captionClassName: _propTypes2.default.string,

  icon: _propTypes2.default.node,

  contentStyle: _propTypes2.default.object,
  contentClassName: _propTypes2.default.string,
  children: _propTypes2.default.node,

  submitStyle: _propTypes2.default.object,
  submitClassName: _propTypes2.default.string,
  submitCaption: _propTypes2.default.node,
  disabled: _propTypes2.default.bool,
  onClickSubmit: _propTypes2.default.func,

  cancelStyle: _propTypes2.default.object,
  cancelClassName: _propTypes2.default.string,
  cancelCaption: _propTypes2.default.node,
  onClickCancel: _propTypes2.default.func
} : {};
module.exports = exports['default'];