'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BiGauge = (_temp = _class = function (_Component) {
  _inherits(BiGauge, _Component);

  function BiGauge(props, context) {
    _classCallCheck(this, BiGauge);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.getDuration = function () {
      var _this$props = _this.props,
          duration = _this$props.duration,
          rotate = _this$props.rotate;

      return duration / 270 * rotate;
    };

    _this.getRotate = function () {
      var rotate = _this.props.rotate;

      return rotate > 270 ? 270 : rotate;
    };

    _this.getBgLvl = function () {
      var rotate = _this.props.rotate;

      var lvl = Math.round(rotate / 27);
      return lvl > 10 ? 10 : 1;
    };

    _this.aniRotate = function () {
      // 时长
      var duration = _this.getDuration();
      // 旋转
      var rotate = _this.getRotate();
      // 背景
      var bgLvl = 'bg' + _this.getBgLvl();
      setTimeout(function () {
        if (_this.$el) {
          _this.$el.style.WebkitAnimationDuration = duration + 'ms';
          _this.$el.classList.add(bgLvl);
        }
        if (_this.$elPointer) {
          _this.$elPointer.style.WebkitTransitionDuration = duration + 'ms';
          _this.$elPointer.style.WebkitTransform = 'rotate(' + rotate + 'deg)';
        }
      }, _this.props.delay);
    };

    return _this;
  }
  // 只有延迟100毫秒动画才会生效


  BiGauge.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        className = _props.className,
        style = _props.style,
        children = _props.children,
        captionClassName = _props.captionClassName,
        captionStyle = _props.captionStyle;
    // 动画旋转

    this.aniRotate();
    return _react2.default.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'bi-gauge-box' + (className ? ' ' + className : ''), style: style },
      _react2.default.createElement(
        'div',
        { className: 'bi-gauge' },
        _react2.default.createElement('div', { ref: function ref(el) {
            _this2.$elPointer = el;
          }, className: 'bi-gauge-pointer' }),
        _react2.default.createElement(
          'div',
          { className: 'bi-gauge-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
          children
        )
      )
    );
  };

  return BiGauge;
}(_react.Component), _class.defaultProps = {
  duration: 1000,
  rotate: 0,
  delay: 100
}, _temp);
exports.default = BiGauge;
BiGauge.propTypes = process.env.NODE_ENV !== "production" ? {
  duration: _propTypes2.default.number, // 时长
  rotate: _propTypes2.default.number, // 最大270
  delay: _propTypes2.default.number, // 延时

  className: _propTypes2.default.string,
  style: _propTypes2.default.object,
  children: _propTypes2.default.node,
  captionClassName: _propTypes2.default.string,
  captionStyle: _propTypes2.default.object
} : {};
module.exports = exports['default'];