'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _instance = require('./instance.js');

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Calendar = (_temp = _class = function (_Component) {
  _inherits(Calendar, _Component);

  function Calendar(props) {
    _classCallCheck(this, Calendar);

    return _possibleConstructorReturn(this, _Component.call(this, props));
  }

  Calendar.prototype.componentDidMount = function componentDidMount() {
    if (this.instance) return;
    var _props = this.props,
        type = _props.type,
        titleFormat = _props.titleFormat,
        disableBeforeDate = _props.disableBeforeDate,
        disableAfterDate = _props.disableAfterDate,
        verticalDrag = _props.verticalDrag,
        defaultDate = _props.defaultDate,
        prevHTML = _props.prevHTML,
        nextHTML = _props.nextHTML,
        onChange = _props.onChange,
        onClick = _props.onClick,
        onError = _props.onError;

    var instance = new _instance2.default(this.$el, {
      viewType: type,
      titleFormat: titleFormat,

      disableBeforeDate: disableBeforeDate,
      disableAfterDate: disableAfterDate,
      verticalDrag: verticalDrag,
      defaultDate: defaultDate,
      prevHTML: prevHTML,
      nextHTML: nextHTML,
      onChange: onChange,
      onClick: onClick,
      onError: onError
    });
    this.instance = instance;
  };

  Calendar.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement('div', { ref: function ref(el) {
        _this2.$el = el;
      }, className: 'calendar' });
  };

  return Calendar;
}(_react.Component), _class.defaultProps = {
  type: 'month',
  verticalDrag: true,
  prevHTML: '&lt',
  nextHTML: '&gt'
}, _temp);
exports.default = Calendar;
Calendar.propTypes = process.env.NODE_ENV !== "production" ? {
  type: _propTypes2.default.string, // week|month
  titleFormat: _propTypes2.default.string, // 标题日期格式化 YYYY年MM月DD日 周E 第W周
  disableBeforeDate: _propTypes2.default.object, // 禁用之前日期
  disableAfterDate: _propTypes2.default.object, // 禁用之后日期
  verticalDrag: _propTypes2.default.bool, // 是否允许垂直拖动
  defaultDate: _propTypes2.default.object, // 默认日期
  prevHTML: _propTypes2.default.string, // 左箭头
  nextHTML: _propTypes2.default.string, // 右箭头
  onChange: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onError: _propTypes2.default.func
} : {};
module.exports = exports['default'];