'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _Carrousel = require('./../Carrousel');

var _Carrousel2 = _interopRequireDefault(_Carrousel);

var _InputPre = require('./../InputPre');

var _InputPre2 = _interopRequireDefault(_InputPre);

var _Button = require('./../Button');

var _Button2 = _interopRequireDefault(_Button);

var _instance = require('./instance.js');

var _instance2 = _interopRequireDefault(_instance);

var _instanceData = require('./instance.data.js');

var _instanceData2 = _interopRequireDefault(_instanceData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Emoji = (_temp = _class = function (_Component) {
  _inherits(Emoji, _Component);

  function Emoji(props) {
    _classCallCheck(this, Emoji);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      // 自动获取焦点
      if (_this.props.autoFocus && prevProps.show !== _this.props.show && _this.props.show === true && _this.$inputPre) {
        _this.$inputPre.$input.focus();
      }
    };

    _this.componentDidMount = function () {
      if (_this.props.autoFocus && _this.$inputPre) _this.$inputPre.$input.focus();
      if (_this.instance) return;
      var instance = new _instance2.default({
        data: _this.props.data,

        mask: _this.$el,
        isClickMaskHide: _this.props.isClickMaskHide,
        onClickMask: _this.onClickMask,

        onClickSubmit: _this.onClickSubmit,

        onChange: _this.props.onChange
      });
      _this.instance = instance;
    };

    _this.onClickMask = function (s, e) {
      if (_this.props.onClickMask) _this.props.onClickMask(Object.getArgs(e, _this.props.args));
    };

    _this.onClickSubmit = function (value, s, e) {
      if (_this.props.onClickSubmit) _this.props.onClickSubmit(value, Object.getArgs(e, _this.props.args));
    };

    _this.getFaceDOM = function () {
      var data = _this.props.data;
      // icons分页变量

      var icons = [];
      var page = 0;
      var index = 0;
      var count = 23;
      // icons分页
      for (var name in data) {
        if (index !== 0 && index % count === 0) {
          page++;
        }
        if (!icons[page]) icons[page] = [];
        icons[page].push({ key: name, value: data[name] });
        index++;
      }
      // 生成DOM
      return icons.map(function (icon, i) {
        return _react2.default.createElement(
          'div',
          { key: 'page' + i, className: 'emoji-carrousel-slide' },
          icon.map(function (item, index) {
            return _react2.default.createElement(
              'a',
              { key: 'face' + index, className: 'emoji-face', 'data-emoji': item.value, title: item.key },
              '\xA0'
            );
          }),
          _react2.default.createElement(
            'a',
            { className: 'emoji-face-delete' },
            '\xA0'
          )
        );
      });
    };

    return _this;
  }
  // 遮罩

  // 提交按钮

  // 表情


  Emoji.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        show = _props.show,
        data = _props.data,
        portal = _props.portal,
        args = _props.args,
        autoFocus = _props.autoFocus,
        value = _props.value,
        placeholder = _props.placeholder,
        isClickMaskHide = _props.isClickMaskHide,
        onClickMask = _props.onClickMask,
        maskClassName = _props.maskClassName,
        maskStyle = _props.maskStyle,
        className = _props.className,
        style = _props.style,
        licon = _props.licon,
        onChange = _props.onChange,
        submitCaption = _props.submitCaption,
        submitStyle = _props.submitStyle,
        submitClassName = _props.submitClassName,
        onClickSubmit = _props.onClickSubmit,
        others = _objectWithoutProperties(_props, ['show', 'data', 'portal', 'args', 'autoFocus', 'value', 'placeholder', 'isClickMaskHide', 'onClickMask', 'maskClassName', 'maskStyle', 'className', 'style', 'licon', 'onChange', 'submitCaption', 'submitStyle', 'submitClassName', 'onClickSubmit']);

    return (0, _reactDom.createPortal)(_react2.default.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'mask emoji-mask' + (show ? ' active' : '') + (maskClassName ? ' ' + maskClassName : ''), style: maskStyle, onClick: this.onClickMask },
      _react2.default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$container = el;
          }, className: 'emoji active' + (className ? ' ' + className : ''), style: style, onClick: this.onClick },
        licon,
        _react2.default.createElement(
          'div',
          { className: 'emoji-edit' },
          _react2.default.createElement(_InputPre2.default, _extends({
            ref: function ref(el) {
              _this2.$inputPre = el;
            },
            className: 'emoji-edit-input',
            inputStyle: { padding: '0' },
            valueBindProp: true,
            value: value,
            onChange: onChange,
            placeholder: placeholder
          }, others)),
          _react2.default.createElement('i', { ref: function ref(el) {
              _this2.$icon = el;
            }, className: 'icon emoji-edit-icon' }),
          _react2.default.createElement(
            _Button2.default,
            { className: 'emoji-edit-submit' + (submitClassName ? ' ' + submitClassName : ''), style: submitStyle, disabled: !value },
            submitCaption
          )
        ),
        _react2.default.createElement(
          _Carrousel2.default,
          { ref: function ref(el) {
              _this2.$carrousel = el;
            }, pagination: true, className: 'carrousel-container emoji-carrousel', style: { display: 'none' } },
          this.getFaceDOM()
        )
      )
    ), this.props.portal || document.getElementById('root'));
  };

  return Emoji;
}(_react.Component), _class.defaultProps = {
  autoFocus: false,
  data: _instanceData2.default,
  placeholder: window._seeds_lang['say_something'] || '说点什么吧...',
  isClickMaskHide: false,
  submitCaption: window._seeds_lang['submit'] || '提交'
}, _temp);
exports.default = Emoji;
Emoji.propTypes = process.env.NODE_ENV !== "production" ? {
  show: _propTypes2.default.bool, // ios内核必须隐藏, 不能移除dom, 弹出时才不会有bug, 所以必须用show
  data: _propTypes2.default.object,

  portal: _propTypes2.default.object,
  args: _propTypes2.default.any,

  autoFocus: _propTypes2.default.bool,

  value: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,

  isClickMaskHide: _propTypes2.default.bool,
  onClickMask: _propTypes2.default.func,

  maskClassName: _propTypes2.default.string,
  maskStyle: _propTypes2.default.object,

  className: _propTypes2.default.string,
  style: _propTypes2.default.object,

  licon: _propTypes2.default.node,

  onChange: _propTypes2.default.func,

  submitStyle: _propTypes2.default.object,
  submitClassName: _propTypes2.default.string,
  submitCaption: _propTypes2.default.node,
  onClickSubmit: _propTypes2.default.func
} : {};
module.exports = exports['default'];