'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _InputText = require('./../InputText');

var _InputText2 = _interopRequireDefault(_InputText);

var _Bridge = require('./../Bridge');

var _Bridge2 = _interopRequireDefault(_Bridge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var InputLocation = (_temp = _class = function (_Component) {
  _inherits(InputLocation, _Component);

  function InputLocation(props) {
    _classCallCheck(this, InputLocation);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onClick = function (value, args) {
      var _this$props = _this.props,
          valueBindProp = _this$props.valueBindProp,
          locationingText = _this$props.locationingText,
          onChange = _this$props.onChange,
          onClick = _this$props.onClick;

      if (onClick) onClick(value, args);
      if (_this.$input.value === locationingText) return;
      // 定位中...
      if (!valueBindProp) {
        _this.$input.value = locationingText;
      }
      _Bridge2.default.getLocation({
        type: 'gcj02',
        success: function success(data) {
          // 客户端中不需要再getAddress
          if (data.address) {
            // 赋值
            if (!valueBindProp) _this.$input.value = data.address;
            if (onChange) onChange(data.address, data, args);
            return;
          }
          _Bridge2.default.getAddress({ // 只支持gcj02
            latitude: data.latitude,
            longitude: data.longitude,
            success: function success(addrs) {
              // 赋值
              if (!valueBindProp) _this.$input.value = addrs.address;
              if (onChange) onChange(addrs.address, data, args);
            },
            fail: function fail(res) {
              // 赋值
              if (!valueBindProp) _this.$input.value = '';
              if (onChange) onChange('', data, args);
              // 提示获取地址失败
              _Bridge2.default.showToast(res.errMsg, { mask: false });
            }
          });
        },
        fail: function fail(res) {
          // 赋值
          if (!valueBindProp) _this.$input.value = '';
          if (onChange) onChange('', null, args);
          // 提示定位失败
          _Bridge2.default.showToast(res.errMsg, { mask: false });
        }
      });
    };

    return _this;
  }

  InputLocation.prototype.componentDidMount = function componentDidMount() {
    this.$el = this.refs.$ComponentInputText.$el;
    this.$input = this.refs.$ComponentInputText.$input;
  };

  InputLocation.prototype.render = function render() {
    var _props = this.props,
        locationingText = _props.locationingText,
        onChange = _props.onChange,
        onClick = _props.onClick,
        others = _objectWithoutProperties(_props, ['locationingText', 'onChange', 'onClick']);

    return _react2.default.createElement(_InputText2.default, _extends({ ref: '$ComponentInputText' }, others, { readOnly: true, onClick: this.onClick }));
  };

  return InputLocation;
}(_react.Component), _class.defaultProps = {
  locationingText: window._seeds_lang['location'] || '定位中...'
}, _temp);
exports.default = InputLocation;
InputLocation.propTypes = process.env.NODE_ENV !== "production" ? {
  valueBindProp: _propTypes2.default.bool,
  locationingText: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  onChange: _propTypes2.default.func
} : {};
module.exports = exports['default'];