'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Loading = (_temp = _class = function (_Component) {
  _inherits(Loading, _Component);

  function Loading(props) {
    _classCallCheck(this, Loading);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {};
    return _this;
  }

  Loading.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        type = _props.type,
        maskStyle = _props.maskStyle,
        maskClassName = _props.maskClassName,
        maskBefore = _props.maskBefore,
        style = _props.style,
        iconClassName = _props.iconClassName,
        iconSrc = _props.iconSrc,
        caption = _props.caption;

    var content = _react2.default.createElement(
      'div',
      null,
      '\u52A0\u8F7D\u4E2D...'
    );
    if (type === 'custom') {
      // 自定义样式
      content = _react2.default.createElement(
        'div',
        { className: 'loading-custom', style: style },
        (iconClassName || iconSrc) && _react2.default.createElement('span', { style: iconSrc ? { backgroundImage: 'url(' + iconSrc + ')' } : {}, className: 'loading-custom-icon' + (iconClassName ? ' ' + iconClassName : '') }),
        caption && _react2.default.createElement(
          'p',
          { className: 'loading-custom-caption' },
          caption
        )
      );
    } else if (type === 'filling') {
      // 填料环
      content = _react2.default.createElement(
        'div',
        { className: 'loading-filling active', style: style },
        _react2.default.createElement('div', { className: 'loading-filling-icon' })
      );
    } else if (type === 'floating') {
      // 流光
      content = _react2.default.createElement(
        'div',
        { className: 'loading-floating animated', style: style },
        _react2.default.createElement(
          'div',
          { className: 'loading-floating-icon' },
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' })
        ),
        _react2.default.createElement(
          'div',
          { className: 'loading-floating-caption' },
          caption
        )
      );
    }
    if (this.props.portal) {
      return (0, _reactDom.createPortal)(_react2.default.createElement(
        'div',
        { className: 'loading-mask mask active' + (maskClassName ? ' ' + maskClassName : ''), style: maskStyle },
        maskBefore,
        content
      ), this.props.portal);
    }
    return _react2.default.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'loading-mask mask active' + (maskClassName ? ' ' + maskClassName : ''), style: maskStyle },
      maskBefore,
      content
    );
  };

  return Loading;
}(_react.Component), _class.defaultProps = {
  caption: window._seeds_lang['loading'] || '正在加载...',
  type: 'floating'
}, _temp);
exports.default = Loading;
Loading.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: _propTypes2.default.object, // 传送至DOM
  type: _propTypes2.default.string, // floating | filling | custom

  maskStyle: _propTypes2.default.object,
  maskClassName: _propTypes2.default.string,
  maskBefore: _propTypes2.default.node,

  style: _propTypes2.default.object,

  iconClassName: _propTypes2.default.string,
  iconSrc: _propTypes2.default.string,
  caption: _propTypes2.default.string
} : {};
module.exports = exports['default'];