'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _instance = require('./instance.js');

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Marquee = (_temp = _class = function (_Component) {
  _inherits(Marquee, _Component);

  function Marquee(props) {
    _classCallCheck(this, Marquee);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (!_this.props.list.equals(prevProps.list)) {
        _this.update();
      }
    };

    _this.componentDidMount = function () {
      if (_this.instance || _this.props.list.length === 0) return;
      _this.init();
    };

    _this.update = function () {
      _this.instance.setStart(0);
      _this.instance.setEnd(_this.props.step * (_this.props.list.length - 1));
      _this.instance.update();
      _this.instance.play();
    };

    _this.init = function () {
      var _this$props = _this.props,
          list = _this$props.list,
          step = _this$props.step,
          duration = _this$props.duration,
          delay = _this$props.delay,
          direction = _this$props.direction,
          loop = _this$props.loop;

      var instance = new _instance2.default(_this.$el, {
        start: 0,
        end: step * (list.length - 1),
        step: step,
        duration: duration,
        delay: delay,
        direction: direction,
        loop: loop
      });
      instance.play();
      _this.instance = instance;
    };

    _this.onClick = function (item, index) {
      if (_this.props.onClick) _this.props.onClick(item, index);
    };

    return _this;
  }

  Marquee.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        className = _props.className,
        style = _props.style,
        list = _props.list,
        contentClassName = _props.contentClassName,
        contentStyle = _props.contentStyle,
        step = _props.step;

    return _react2.default.createElement(
      'ul',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'marquee' + (className ? ' ' + className : ''), style: style },
      list && list.map(function (item, index) {
        return _react2.default.createElement(
          'li',
          { className: 'marquee-li' + (contentClassName ? ' ' + contentClassName : ''), style: Object.assign({ height: step + 'px' }, contentStyle), key: index, onClick: function onClick() {
              _this2.onClick(item, index);
            } },
          item.value
        );
      })
    );
  };

  return Marquee;
}(_react.Component), _class.defaultProps = {
  step: 50,
  duration: 300,
  delay: 2000,
  direction: 'top',
  loop: true
}, _temp);
exports.default = Marquee;
Marquee.propTypes = process.env.NODE_ENV !== "production" ? {
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  list: _propTypes2.default.array, // [{key: 'xx', value: ''}]

  contentStyle: _propTypes2.default.object,
  contentClassName: _propTypes2.default.string,

  step: _propTypes2.default.number,
  duration: _propTypes2.default.number,
  delay: _propTypes2.default.number,
  direction: _propTypes2.default.string, // top | bottom | left | right
  loop: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
} : {};
module.exports = exports['default'];