'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _NumBox = require('./../NumBox');

var _NumBox2 = _interopRequireDefault(_NumBox);

var _NumBoxPop = require('./../NumBoxPop');

var _NumBoxPop2 = _interopRequireDefault(_NumBoxPop);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NumBoxPopPointer = (_temp = _class = function (_Component) {
  _inherits(NumBoxPopPointer, _Component);

  function NumBoxPopPointer(props) {
    _classCallCheck(this, NumBoxPopPointer);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onClickCancel = function () {
      _this.setState({ show: false });
    };

    _this.onClickPlus = function (value, args) {
      if (_this.props.onChange) _this.props.onChange(value, args);
    };

    _this.onClickMinus = function (value, args) {
      if (_this.props.onChange) _this.props.onChange(value, args);
    };

    _this.onClickSubmit = function (value, args) {
      // Callback
      if (_this.props.onChange) _this.props.onChange(value, args);
      // 隐藏
      _this.setState({
        show: false
      });
    };

    _this.onClickNumBox = function () {
      _this.setState({
        show: true
      });
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  NumBoxPopPointer.prototype.render = function render() {
    var _props = this.props,
        args = _props.args,
        containerClassName = _props.containerClassName,
        containerStyle = _props.containerStyle,
        className = _props.className,
        style = _props.style,
        value = _props.value,
        disabled = _props.disabled,
        min = _props.min,
        max = _props.max,
        digits = _props.digits,
        unitClassName = _props.unitClassName,
        unitStyle = _props.unitStyle,
        unit = _props.unit,
        onChange = _props.onChange,
        others = _objectWithoutProperties(_props, ['args', 'containerClassName', 'containerStyle', 'className', 'style', 'value', 'disabled', 'min', 'max', 'digits', 'unitClassName', 'unitStyle', 'unit', 'onChange']);

    var show = this.state.show;

    return _react2.default.createElement(
      'div',
      { style: Object.assign({ position: 'relative' }, containerStyle), className: containerClassName },
      _react2.default.createElement(_NumBox2.default, {
        args: args,
        className: className,
        style: style,
        value: value,
        disabled: disabled,
        readOnly: true,
        min: min,
        max: max,
        digits: digits,
        onClickInput: this.onClickNumBox,
        onClickPlus: this.onClickPlus,
        onClickMinus: this.onClickMinus
      }),
      _react2.default.createElement(
        'span',
        { style: unitStyle, className: unitClassName },
        unit || ''
      ),
      show && _react2.default.createElement(_NumBoxPop2.default, _extends({
        args: args,
        value: value,
        min: min,
        max: max,
        digits: digits,
        onClickCancel: this.onClickCancel,
        onClickSubmit: this.onClickSubmit
      }, others))
    );
  };

  return NumBoxPopPointer;
}(_react.Component), _class.defaultProps = {
  className: 'sm',
  unitStyle: {
    fontSize: '13px',
    marginLeft: '8px'
  }
}, _temp);
exports.default = NumBoxPopPointer;
NumBoxPopPointer.propTypes = process.env.NODE_ENV !== "production" ? {
  args: _propTypes2.default.any,
  containerClassName: _propTypes2.default.string,
  containerStyle: _propTypes2.default.object,
  // numbox
  className: _propTypes2.default.string,
  style: _propTypes2.default.object,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  digits: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.number]),
  min: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  max: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  disabled: _propTypes2.default.bool,
  // unit
  unitClassName: _propTypes2.default.string,
  unitStyle: _propTypes2.default.object,
  unit: _propTypes2.default.string,
  // events
  onChange: _propTypes2.default.func
} : {};
module.exports = exports['default'];