'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Page = require('./../Page');

var _Page2 = _interopRequireDefault(_Page);

var _instance = require('./instance.js');

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PagePull = (_temp = _class = function (_Component) {
  _inherits(PagePull, _Component);

  function PagePull(props, context) {
    _classCallCheck(this, PagePull);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.componentDidMount = function () {
      var instance = new _instance2.default(_this.$el, {
        drag: true,
        transition: _this.props.transition || 'push',
        onShowedLeft: _this.props.onShowedLeft,
        onShowedRight: _this.props.onShowedRight
      });
      _this.instance = instance;
    };

    return _this;
  }

  PagePull.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        lSide = _props.lSide,
        lSideStyle = _props.lSideStyle,
        lSideClassName = _props.lSideClassName,
        rSide = _props.rSide,
        rSideStyle = _props.rSideStyle,
        rSideClassName = _props.rSideClassName,
        drag = _props.drag,
        children = _props.children,
        transition = _props.transition,
        others = _objectWithoutProperties(_props, ['lSide', 'lSideStyle', 'lSideClassName', 'rSide', 'rSideStyle', 'rSideClassName', 'drag', 'children', 'transition']);

    return _react2.default.createElement(
      'div',
      { className: 'page-pull', ref: function ref(el) {
          _this2.$el = el;
        } },
      _react2.default.createElement(
        _Page2.default,
        others,
        children,
        _react2.default.createElement('div', { className: 'mask' })
      ),
      lSide && _react2.default.createElement(
        'aside',
        { className: 'page-side-left' + (lSideClassName ? ' ' + lSideClassName : ''), style: lSideStyle, 'data-transition': transition, ref: function ref(el) {
            _this2.$lSide = el;
          } },
        lSide
      ),
      rSide && _react2.default.createElement(
        'aside',
        { className: 'page-side-right' + (rSideClassName ? ' ' + rSideClassName : ''), style: rSideStyle, 'data-transition': transition, ref: function ref(el) {
            _this2.$rSide = el;
          } },
        rSide
      )
    );
  };

  return PagePull;
}(_react.Component), _class.defaultProps = {
  drag: true,
  transition: 'push'
}, _temp);
exports.default = PagePull;
PagePull.propTypes = process.env.NODE_ENV !== "production" ? {
  // Page
  children: _propTypes2.default.node,
  // Side 侧边栏
  drag: _propTypes2.default.bool,
  lSide: _propTypes2.default.node, // 左侧边栏
  lSideStyle: _propTypes2.default.object,
  lSideClassName: _propTypes2.default.string,
  rSide: _propTypes2.default.node, // 右侧边栏
  rSideStyle: _propTypes2.default.object,
  rSideClassName: _propTypes2.default.string,
  transition: _propTypes2.default.string, // 过渡动画, push | reveal
  onShowedLeft: _propTypes2.default.func,
  onShowedRight: _propTypes2.default.func
} : {};
module.exports = exports['default'];