'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _instance = require('./instance.js');

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var PickerDate = (_temp = _class = function (_Component) {
  _inherits(PickerDate, _Component);

  function PickerDate(props) {
    _classCallCheck(this, PickerDate);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {
      _this.initInstance();
    };

    _this.shouldComponentUpdate = function (nextProps) {
      if (nextProps.show === _this.props.show) return false;
      return true;
    };

    _this.componentDidUpdate = function () {
      if (_this.instance) {
        if (_this.props.show) {
          _this.setDefault();
          _this.instance.show();
        } else _this.instance.hide();
      }
    };

    _this.setDefault = function () {
      var def = _this.getDefault();
      _this.instance.setDefaults(def);
      _this.instance.update();
    };

    _this.getDefault = function () {
      var _this$props = _this.props,
          split = _this$props.split,
          type = _this$props.type,
          onError = _this$props.onError;

      var defaultValue = _this.props.valueForKey || _this.props.value;
      var now = new Date();
      var nowYear = now.getFullYear();
      var nowMonth = now.getMonth() + 1;
      var nowDate = now.getDate();
      var nowHour = now.getHours();
      var nowMinute = now.getMinutes();
      var defaultYear = nowYear;
      var defaultMonth = nowMonth < 10 ? '0' + nowMonth : nowMonth;
      var defaultDay = nowDate < 10 ? '0' + nowDate : nowDate;
      var defaultHour = nowHour < 10 ? '0' + nowHour : nowHour;
      var defaultMinute = nowMinute < 10 ? '0' + nowMinute : nowMinute;
      // 默认值
      if (type === 'date') {
        // 如果不是合法的日期格式
        if (!defaultValue || !new RegExp('^[0-9]{4}' + (split || '-') + '[0-9]{2}' + (split || '-') + '[0-9]{2}$').test(defaultValue)) {
          if (onError) onError('' + (window._seeds_lang['hint_invalid_date'] || '无效的日期格式'));
        } else {
          var dateValues = defaultValue.split(_this.props.split);
          defaultYear = dateValues[0];
          defaultMonth = dateValues[1];
          defaultDay = dateValues[2] || '01';
        }
      } else if (type === 'month') {
        // 如果不是合法的日期格式
        if (!defaultValue || !new RegExp('^[0-9]{4}' + (split || '-') + '[0-9]{2}$').test(defaultValue)) {
          if (onError) onError((window._seeds_lang['hint_invalid_date'] || '无效的日期格式') + ', YYYY-MM-DD');
        } else {
          var monthValues = defaultValue.split(_this.props.split);
          defaultYear = monthValues[0];
          defaultMonth = monthValues[1];
        }
      } else if (type === 'datetime') {
        // 如果不是合法的日期格式
        if (!defaultValue || !new RegExp('^[0-9]{4}' + (split || '-') + '[0-9]{2}' + (split || '-') + '[0-9]{2}\\s[0-9]{2}:[0-9]{2}(:[0-9]{2})?$').test(defaultValue)) {
          if (onError) onError((window._seeds_lang['hint_invalid_date'] || '无效的日期格式') + ', YYYY-MM-DD hh:mm');
        } else {
          var values = defaultValue.split(' ');
          var _dateValues = values[0].split(_this.props.split);
          var timeValues = values[1].split(':');
          defaultYear = _dateValues[0];
          defaultMonth = _dateValues[1];
          defaultDay = _dateValues[2];
          defaultHour = timeValues[0];
          defaultMinute = timeValues[1];
        }
      } else if (type === 'time') {
        // 如果不是合法的日期格式
        if (!defaultValue || !new RegExp('^[0-9]{2}:[0-9]{2}(:[0-9]{2})?$').test(defaultValue)) {
          if (onError) onError((window._seeds_lang['hint_invalid_date'] || '无效的日期格式') + ', hh:mm');
        } else {
          var _timeValues = defaultValue.split(':');
          defaultHour = _timeValues[0];
          defaultMinute = _timeValues[1];
        }
      }
      return {
        year: defaultYear,
        month: defaultMonth,
        day: defaultDay,
        hour: defaultHour,
        minute: defaultMinute
      };
    };

    _this.getData = function () {
      // 自定义数据
      var yearsData = null;
      var monthsData = null;
      var daysData = null;
      var hoursData = null;
      var minutesData = null;
      if (_this.props.data) {
        if (_this.props.data.year) {
          yearsData = _this.props.data.year.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + (window._seeds_lang['unit_year'] || '年')
            };
          });
        }
        if (_this.props.data.month) {
          monthsData = _this.props.data.month.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + (window._seeds_lang['unit_month'] || '月')
            };
          });
        }
        if (_this.props.data.day) {
          daysData = _this.props.data.day.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + (window._seeds_lang['unit_date'] || '日')
            };
          });
        }
        if (_this.props.data.hour) {
          hoursData = _this.props.data.hour.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + (window._seeds_lang['unit_hour'] || '时')
            };
          });
        }
        if (_this.props.data.minute) {
          minutesData = _this.props.data.minute.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + (window._seeds_lang['unit_minute'] || '分')
            };
          });
        }
      }
      return {
        yearsData: yearsData,
        monthsData: monthsData,
        daysData: daysData,
        hoursData: hoursData,
        minutesData: minutesData
      };
    };

    _this.initInstance = function () {
      var data = _this.getData();
      var def = _this.getDefault();
      // render数据
      var instance = new _instance2.default({
        mask: _this.$el,
        split: _this.props.split,
        viewType: _this.props.type,
        yearsData: data.yearsData,
        monthsData: data.monthsData,
        daysData: data.daysData,
        hoursData: data.hoursData,
        minutesData: data.minutesData,
        defaultYear: def.year,
        defaultMonth: def.month,
        defaultDay: def.day,
        defaultHour: def.hour,
        defaultMinute: def.minute,
        onClickMask: function onClickMask(e) {
          if (_this.props.onClickMask) _this.props.onClickMask(e);
        },
        onClickCancel: function onClickCancel(e) {
          // e.hide()
          if (_this.props.onClickCancel) _this.props.onClickCancel(e);
        },
        onClickSubmit: function onClickSubmit(e) {
          // e.hide()
          if (_this.props.onClickSubmit) _this.props.onClickSubmit(e);
        },
        onHid: function onHid(e) {}
      });
      if (_this.props.show && instance) {
        setTimeout(function () {
          instance.show();
        }, 10);
      }
      _this.instance = instance;
    };

    return _this;
  }

  PickerDate.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        maskClassName = _props.maskClassName,
        maskStyle = _props.maskStyle,
        className = _props.className,
        style = _props.style;

    return (0, _reactDom.createPortal)(_react2.default.createElement(
      'div',
      { className: 'mask picker-mask' + (maskClassName ? ' ' + maskClassName : ''), style: maskStyle, ref: function ref(el) {
          _this2.$el = el;
        } },
      _react2.default.createElement(
        'div',
        { className: 'picker' + (className ? ' ' + className : ''), style: style },
        _react2.default.createElement(
          'div',
          { className: 'picker-header' },
          _react2.default.createElement(
            'a',
            { className: 'picker-cancel' },
            window._seeds_lang['cancel'] || '取消'
          ),
          _react2.default.createElement(
            'a',
            { className: 'picker-submit' },
            window._seeds_lang['finish'] || '完成'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'picker-wrapper' },
          _react2.default.createElement(
            'div',
            { className: 'picker-layer' },
            _react2.default.createElement('div', { className: 'picker-layer-frame' })
          ),
          _react2.default.createElement('div', { className: 'picker-slotbox' })
        )
      )
    ), this.props.portal || document.getElementById('root'));
  };

  return PickerDate;
}(_react.Component), _class.defaultProps = {
  split: '-',
  type: 'date'
}, _temp);
exports.default = PickerDate;
PickerDate.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: _propTypes2.default.object,
  split: _propTypes2.default.string,
  type: _propTypes2.default.string, // 'date','month','time','datetime'

  maskClassName: _propTypes2.default.string,
  maskStyle: _propTypes2.default.object,
  className: _propTypes2.default.string,
  style: _propTypes2.default.object,

  data: _propTypes2.default.object, // {year: [], month: [], day: [], hour: [], minute: []}
  value: _propTypes2.default.string, // 例: 2018-02-26
  valueForKey: _propTypes2.default.string,

  show: _propTypes2.default.bool,
  onClickMask: _propTypes2.default.func,
  onClickCancel: _propTypes2.default.func,
  onClickSubmit: _propTypes2.default.func,
  onError: _propTypes2.default.func
} : {};
module.exports = exports['default'];