'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Device = require('../Device');

var _Device2 = _interopRequireDefault(_Device);

var _FullScreen = require('../FullScreen');

var _FullScreen2 = _interopRequireDefault(_FullScreen);

var _MediaUtil = require('../MediaUtil');

var _MediaUtil2 = _interopRequireDefault(_MediaUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Player = (_temp = _class = function (_Component) {
  _inherits(Player, _Component);

  function Player(props) {
    _classCallCheck(this, Player);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onClick = function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(Object.getArgs(e, _this.props.args));
      } else {
        var target = e.currentTarget.querySelector('video');
        _FullScreen2.default.enter(target);

        setTimeout(function () {
          target.play();
        }, 500);
      }
      e.stopPropagation();
    };

    _this.getType = function () {
      var src = _this.props.src;

      return _MediaUtil2.default.sourceType(src);
    };

    return _this;
  }

  Player.prototype.componentDidMount = function componentDidMount() {
    var video = this.$video;
    _FullScreen2.default.addHandler(video, function (e) {
      if (_FullScreen2.default.isFull(video)) {
        video.play();
      } else {
        video.pause();
      }
    });
  };

  Player.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        args = _props.args,
        children = _props.children,
        style = _props.style,
        className = _props.className,
        src = _props.src,
        onClick = _props.onClick,
        others = _objectWithoutProperties(_props, ['args', 'children', 'style', 'className', 'src', 'onClick']);
    // Andriod


    if (_Device2.default.os === 'andriod' || onClick) {
      return _react2.default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'player-thumbnail' + (className ? ' ' + className : ''), style: style, onClick: this.onClick },
        !onClick && _react2.default.createElement(
          'video',
          _extends({ ref: function ref(el) {
              _this2.$video = el;
            } }, others),
          _react2.default.createElement('source', { src: src, type: this.getType() }),
          '\u60A8\u7684\u6D4F\u89C8\u5668\u4E0D\u652F\u6301 video \u6807\u7B7E\u3002'
        ),
        this.props.poster && _react2.default.createElement('div', { style: { backgroundImage: 'url(' + this.props.poster + ')' }, className: 'player-thumbnail-poster' }),
        _react2.default.createElement('div', { className: 'player-thumbnail-button' }),
        children
      );
    }
    // Ios
    return _react2.default.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'player-thumbnail' + (className ? ' ' + className : ''), style: style },
      _react2.default.createElement(
        'video',
        _extends({ controls: true, ref: function ref(el) {
            _this2.$video = el;
          } }, others),
        _react2.default.createElement('source', { src: src, type: this.getType() }),
        '\u60A8\u7684\u6D4F\u89C8\u5668\u4E0D\u652F\u6301 video \u6807\u7B7E\u3002'
      ),
      children
    );
  };

  return Player;
}(_react.Component), _class.defaultProps = {}, _temp);
exports.default = Player;
Player.propTypes = process.env.NODE_ENV !== "production" ? {
  args: _propTypes2.default.any,
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,

  src: _propTypes2.default.string,
  onClick: _propTypes2.default.func
} : {};
module.exports = exports['default'];