'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Popover = (_temp = _class = function (_Component) {
  _inherits(Popover, _Component);

  function Popover(props) {
    _classCallCheck(this, Popover);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {};

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(Object.getArgs(e, _this.props.args));
      e.stopPropagation();
    };

    return _this;
  }

  Popover.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        show = _props.show,
        maskClassName = _props.maskClassName,
        maskStyle = _props.maskStyle,
        className = _props.className,
        style = _props.style,
        animation = _props.animation,
        children = _props.children;

    return (0, _reactDom.createPortal)(_react2.default.createElement(
      'div',
      { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'mask popover-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: maskStyle, onClick: this.onClickMask },
      _react2.default.createElement(
        'div',
        { style: style, className: 'popover' + (className ? ' ' + className : '') + (show ? ' active' : ''), 'data-animation': animation },
        children && children
      )
    ), this.props.portal || document.getElementById('root'));
  };

  return Popover;
}(_react.Component), _class.defaultProps = {
  isClickMaskHide: true,
  animation: 'zoom'
}, _temp);
exports.default = Popover;
Popover.propTypes = process.env.NODE_ENV !== "production" ? {
  args: _propTypes2.default.any,
  portal: _propTypes2.default.object,
  show: _propTypes2.default.bool,

  animation: _propTypes2.default.string, // slideLeft | slideRight | slideUp | slideDown | zoom | fade
  isClickMaskHide: _propTypes2.default.bool,

  maskClassName: _propTypes2.default.string,
  maskStyle: _propTypes2.default.object,
  onClickMask: _propTypes2.default.func,

  className: _propTypes2.default.string,
  style: _propTypes2.default.object,

  children: _propTypes2.default.node
} : {};
module.exports = exports['default'];