'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Radio = (_temp = _class = function (_Component) {
  _inherits(Radio, _Component);

  function Radio(props) {
    _classCallCheck(this, Radio);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onClick = function (e) {
      if (_this.props.disabled) return;
      if (_this.props.onClick) {
        _this.props.onClick(_this.$input.checked, Object.getArgs(e, _this.props.args));
      }
    };

    return _this;
  }

  Radio.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        style = _props.style,
        className = _props.className,
        name = _props.name,
        value = _props.value,
        checked = _props.checked,
        caption = _props.caption,
        captionClassName = _props.captionClassName,
        captionStyle = _props.captionStyle;

    return _react2.default.createElement(
      'div',
      { className: 'radio-box' + (className ? ' ' + className : ''), onClick: this.onClick, style: style },
      _react2.default.createElement('input', { readOnly: true, checked: checked, type: 'radio', className: 'radio events-none', name: name, value: value, ref: function ref(el) {
          _this2.$input = el;
        } }),
      caption && _react2.default.createElement(
        'span',
        { className: 'radio-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
        caption
      )
    );
  };

  return Radio;
}(_react.Component), _class.defaultProps = {
  args: null,
  value: '',
  checked: false
}, _temp);
exports.default = Radio;
Radio.propTypes = process.env.NODE_ENV !== "production" ? {
  args: _propTypes2.default.any,
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func,

  name: _propTypes2.default.string,
  value: _propTypes2.default.string,
  checked: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,

  caption: _propTypes2.default.string,
  captionClassName: _propTypes2.default.string,
  captionStyle: _propTypes2.default.object
} : {};
module.exports = exports['default'];