'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DB = require('./../DB');

var _DB2 = _interopRequireDefault(_DB);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchBoard = (_temp = _class = function (_Component) {
  _inherits(SearchBoard, _Component);

  function SearchBoard(props, context) {
    _classCallCheck(this, SearchBoard);

    // 初始化标签
    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.onClear = function () {
      _DB2.default.removeStore(_this.props.dbKey);
      _this.setState({
        tags: []
      });
      if (_this.props.onClear) _this.props.onClear();
    };

    _this.add = function (item) {
      if (!item.value) return;
      var tags = _DB2.default.getStore(_this.props.dbKey) || [];
      // 删除重复项
      for (var i in tags) {
        if (tags[i].value === item.value) {
          tags.splice(i, 1);
          break;
        }
      }
      // 添加到第一项
      tags.unshift(item);
      _DB2.default.setStore(_this.props.dbKey, tags);
      _this.setState({
        tags: tags
      });
    };

    _this.state = {
      tags: _DB2.default.getStore(_this.props.dbKey) || []
    };
    return _this;
  }
  // 清空历史记录

  // 新增历史记录


  SearchBoard.prototype.render = function render() {
    var tags = this.state.tags;
    var _props = this.props,
        style = _props.style,
        className = _props.className,
        show = _props.show,
        expandCaption = _props.expandCaption,
        expandTags = _props.expandTags,
        _onClick = _props.onClick,
        onClickExpand = _props.onClickExpand,
        children = _props.children;

    var isHide = false;
    if (this.props.showValidTags && tags.length === 0) {
      isHide = true;
    }
    var DOM = null;
    if (!isHide) {
      DOM = _react2.default.createElement(
        'div',
        { className: 'searchboard ' + (className ? ' ' + className : '') + (show ? '' : ' hide'), style: style },
        tags.length > 0 && _react2.default.createElement(
          'div',
          { className: 'searchboard-caption' },
          _react2.default.createElement(
            'div',
            { className: 'searchboard-caption-title' },
            '\u641C\u7D22\u5386\u53F2'
          ),
          _react2.default.createElement(
            'div',
            { className: 'searchboard-caption-ricon', onClick: this.onClear },
            _react2.default.createElement('i', { className: 'searchboard-icon-trash' }),
            _react2.default.createElement(
              'span',
              null,
              '\u6E05\u9664'
            )
          )
        ),
        tags.map(function (item, index) {
          return _react2.default.createElement(
            'div',
            { className: 'searchboard-tag', onClick: function onClick() {
                if (_onClick) _onClick(item, index);
              }, key: index },
            item.value
          );
        }),
        expandCaption && _react2.default.createElement(
          'div',
          { className: 'searchboard-caption' },
          _react2.default.createElement(
            'div',
            { className: 'searchboard-caption-title' },
            expandCaption
          )
        ),
        expandTags && expandTags.map(function (item, index) {
          return _react2.default.createElement(
            'div',
            { className: 'searchboard-tag', onClick: function onClick() {
                if (onClickExpand) onClickExpand(item, index);
              }, key: index },
            item.value
          );
        }),
        children
      );
    }
    return DOM;
  };

  return SearchBoard;
}(_react.Component), _class.defaultProps = {
  show: true,
  showValidTags: true,
  className: 'border-b',
  dbKey: 'app_search_history'
}, _temp);
exports.default = SearchBoard;
SearchBoard.propTypes = process.env.NODE_ENV !== "production" ? {
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  dbKey: _propTypes2.default.string, // 存储到db中的key
  show: _propTypes2.default.bool,
  showValidTags: _propTypes2.default.bool, // 如果没有历史记录是否隐藏面板
  onClick: _propTypes2.default.func,
  onClear: _propTypes2.default.func,
  expandCaption: _propTypes2.default.string, // 扩展标题
  expandTags: _propTypes2.default.array, // 扩展标签, 格式: {value: 'xx'}
  onClickExpand: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};
module.exports = exports['default'];